set_parameter LOCAL_RAMS 1
set_parameter SHARED_LOCAL_RAMS 1
set_parameter GROUP_RAMS 0
set_parameter GROUP_RAMS_SIMPLE_OFFSET 0
set_parameter CASE_FSM 1

set_parameter ANDERSEN_POINTSTO_ANALYSIS 1

###############################################################################
#------------------------------------------------------------------------------
# malloc() & free(): options                                                   
#------------------------------------------------------------------------------
#   +-- If statically declared arrays exist, move to malloc calls (possibly save memory).
set_parameter ALLOCA_REPLACE 1
#
#  +-- Replace malloc() and free() calls with synthesizable C-cores
set_parameter AUTO_MALLOC 1
#
#  +-- Use Valgrind to profile the program's heap size.
set_parameter PROFILE_HEAPS 1
#
#  +-- Set the heap size manually, [Default is 65536 Bytes]
set_parameter HEAP_SIZE 65536
#
#  +-- Set the minimum request size (buddy and bit ONLY) [Default is 0 Bytes - OFF, for Buddy and Bit, please set to 16].
set_parameter MIN_REQ_SIZE 0
#
#  +-- Divide the heap size amongst each thread in the program [Experimental... ]
set_parameter ASSIGN_HEAP_2_THREAD 0
#
#  +-- Select which memory allocation scheme one desires.                      
# [0] - [gnu_*] GNU-Implementation of malloc and free                                  
# [1] - [lin_*] Linear Allocator                                                       
# [2] - [bit_*] Bit Map Allocator, uses bits to check for free memory of a certain size
# [3] - [lut_*] Look-up based allocation (mix between bud and bit)                                           
# [4] - [bud_*] Buddy Allocation                                                      
set_parameter ALLOC_SCHEME 0
#  +-- Save Cycles By freeing periodically. [Experimental...]
set_parameter LAZY_FREE 0
#
#   +-- Select how many heaps (if AUTO_MALLOC == 1).
set_parameter NUM_HEAPS 4
#------------------------------------------------------------------------------


# For MC Paths
#set_parameter MULTI_CYCLE_REMOVE_REG 1
#set_parameter MULTI_CYCLE_DISABLE_REG_MERGING 1
#set_parameter MULTI_CYCLE_DUPLICATE_LOAD_REG 1
#set_parameter MULTI_CYCLE_REMOVE_CMP_REG 1
#set_operation_latency local_mem_dual_port 2

# For MC Paths, based on SW profiling
#set_parameter LLVM_PROFILE 1
#set_parameter LLVM_PROFILE_MAX_BB_FREQ_TO_ALTER 1
#set_parameter LLVM_PROFILE_EXTRA_CYCLES 1

