#include "cnn.h"
#include <stdio.h>

static long total = 0;

__attribute__((noinline)) void convolution() {

  int om; // output map index
  int im; // input map index
  int row, col; // row, col indices in output map
  int i,j; // filter indices

  volatile int NUM_INPUT_MAPS = INPUT_MAPS; // prevent LLVM from inlining
  volatile int FILTER_D = FILTER_DIM; // prevent LLVM from inlining
  
  for (om = 0; om < OUTPUT_MAPS; om++) {
    for (row = 0; row < OUTPUT_DIM; row++) {
      for (col = 0; col < OUTPUT_DIM; col++) {
	short output_fm_value = 0;
	for (i = 0; i < FILTER_D; i++) {
	  for (j = 0; j < FILTER_D; j++) {
	    for (im = 0; im < NUM_INPUT_MAPS; im+=1) {
	      output_fm_value += weights[om][i][j][im] * input_fms[row+i][col+j][im];
	    }
	  }
	}
	output_fms[row][col][om] = output_fm_value;
	total += output_fm_value; // for correctness checking
      }
    }
  }
}

int main(void) {

  convolution();
  printf("TOTAL: %ld\n", total);
  if (total == -18870)
    printf("PASS\n");
  else
    printf("FAIL\n");
  
  return 0;
}
